;; Map-Editor


timer = CreateTimer(60);

; Konstanten fr Grsse des Fensters
Const graph_x = 1024
Const graph_y = 768

Graphics graph_x, graph_y, 0, 2

SetBuffer BackBuffer();


; Name der Welt
world$ = "world01";


; Textur laden (evtl. spter aus Levelfile auslesen)
textur_path$ = "img/gras.png"

textur_img = LoadImage(textur_path);


; Positive Startposition
s_x = 0;
s_y = 0;


; Anzahl der Entity (evtl. spter Count einbauen)
anz_elements = 1;

; Dim-Feld fr die Bilder der Entitys
Dim entity_image(anz_elements);
	
entity_image(1) = LoadImage("img/entity/standart/enity1.PNG");
MaskImage entity_image(1), 0,0,0



; Types

Type ZuLadenderSektor
	Field x, y
End Type

Type GeladenerSektor
	Field x, y
	Field name$
End Type

Type Entity
	Field x, y
	Field typ
	Field sektor$
End Type


; Einstellungen fr Editor
Const scroll_spead = 5;


Const sektor_size = 2000;
Const wrapper_width = 100;

Repeat


	Cls
	
	
	Color 255,0,0
	
	; Textur darstellen
	TileBlock textur_img, s_x, s_y;
	
	e_x = Abs(s_x)
	e_y = Abs(s_y)
	

	Delete Each ZuLadenderSektor

	; Primre Sektoren
	zls.ZuLadenderSektor = New ZuLadenderSektor
	zls.ZuLadenderSektor = Last ZuLadenderSektor
	
	zls\x = (e_x/sektor_size) * sektor_size;
	zls\y = (e_y/sektor_size) * sektor_size;

	zs_x = zls\x
	zs_y = zls\y

	; Sekundre Sektoren  X
	If(((e_x + graph_x) / sektor_size) * sektor_size <> zs_x ) Then
		zls.ZuLadenderSektor = New ZuLadenderSektor
		zls.ZuLadenderSektor = Last ZuLadenderSektor

		zls\x = ((e_x+graph_x)/sektor_size) * sektor_size;
		zls\y = zs_y;
	EndIf
	
	
	
	; Sekundre Sektoren  Y
	If(((e_y + graph_y) / sektor_size) * sektor_size <> zs_y ) Then
		zls.ZuLadenderSektor = New ZuLadenderSektor
		zls.ZuLadenderSektor = Last ZuLadenderSektor

		zls\x = zs_x;
		zls\y = ((e_y + graph_y) / sektor_size) * sektor_size;
		
		If(((e_x + graph_x) / sektor_size) * sektor_size <> zs_x ) Then
			zls.ZuLadenderSektor = New ZuLadenderSektor
			zls.ZuLadenderSektor = Last ZuLadenderSektor
			zls\x = ((e_x+graph_x)/sektor_size) * sektor_size;
			zls\y = ((e_y + graph_y) / sektor_size) * sektor_size;
		EndIf
		
	EndIf

 	; Sektor nachladen
	For zls.ZuLadenderSektor = Each ZuLadenderSektor
		fund = False;
		
		For gs.GeladenerSektor = Each GeladenerSektor
			If(zls\x = gs\x And zls\y = gs\y)
				fund = True;
			EndIf
		Next
		
		If(fund = False)
			; Der Sektor muss nachgeladen werden
			
			gs.GeladenerSektor = New GeladenerSektor;
			gs\x = zls\x;
			gs\y = zls\y;
			gs\name = zls\x + "_" + zls\y
			
			; File ffnen
			mapfile = ReadFile("map/"+world+"/"+gs\name+".map");
			
			; Falls die Datei existiert, werden die Entity eingelesen
			If(mapfile<>0)
			
				Repeat
					eni.Entity = New Entity
					eni\typ = ReadShort(mapfile)

					eni\x = (ReadInt(mapfile) + gs\x)
					eni\y = (gs\y + ReadInt(mapfile))
							
					eni\sektor = gs\name
				Until Eof(mapfile)
				
				CloseFile mapfile
				
			EndIf
		Else
			; Der Sektor wurde bereits geladen
		EndIf
	Next
	
	
	
	; Vorhandene Sektoren, welche nichtmehr verwendet werden, lschen
	For gs.GeladenerSektor = Each GeladenerSektor
	
		fund = False
		
		For zls.ZuLadenderSektor = Each ZuLadenderSektor
		
			If(zls\x = gs\x And zls\y = gs\y)
				
				fund = True
				
			EndIf
		
		Next	
		
		If(fund = False)
			; Sektor lschen
			
			For ent.Entity = Each Entity
			
				If(ent\sektor = gs\name)
					Delete ent
				EndIf
			
			Next
			
			Delete gs
		EndIf
	
	Next
	
	


	; Elemente darstellen	
	For ent.Entity = Each Entity
		If s_x+ent\x<graph_x+wrapper_width And s_x+ent\X>(-1*wrapper_width) And s_y+ent\Y<graph_y And s_y+ent\Y>(-1*wrapper_width) Then 
		
			DrawImage entity_image(ent\typ), ent\x+s_x,s_y+(ent\y)
			
		EndIf
	Next	
	
	
	; Steuerung
	If(KeyDown(203))
		s_x = s_x + scroll_spead;
	EndIf
	
	If(KeyDown(205))
		s_x = s_x - scroll_spead;
	EndIf
	
	If(KeyDown(200))
		s_y = s_y + scroll_spead;
	EndIf
	
	If(KeyDown(208))
		s_y = s_y - scroll_spead;
	EndIf

	; Ausgabe der aktuellen Position
	Text 10, 30, "X-Pos:  "+e_x;
	Text 10, 50, "Y-Pos:  "+e_y;
	
	
	WaitTimer(timer);
	
	Flip 0

Until KeyHit(1)


End